﻿namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        List<Monkey> list = new List<Monkey>();

        for(int i = 0; i < 10; i++)
        {
            list.Add
            (
                new Monkey
                {
                    Name     = "Baboon",
                    Location = "Africa and Asia",
                    ImageURL = "https://upload.wikimedia.org/wikipedia/commons/thumb/f/fc/Papio_anubis_%28Serengeti%2C_2009%29.jpg/200px-Papio_anubis_%28Serengeti%2C_2009%29.jpg"
                }
            );

            list.Add
            (
                new Monkey
                {
                    Name     = "Capuchin Monkey",
                    Location = "Central and South America",
                    ImageURL = "https://upload.wikimedia.org/wikipedia/commons/thumb/4/40/Capuchin_Costa_Rica.jpg/200px-Capuchin_Costa_Rica.jpg"
                }
            );

            list.Add
            (
                new Monkey
                {
                    Name     = "Blue Monkey",
                    Location = "Central and East Africa",
                    ImageURL = "https://upload.wikimedia.org/wikipedia/commons/thumb/8/83/BlueMonkey.jpg/220px-BlueMonkey.jpg"
                }
            );
        }

        this.collectionView.ItemsSource = list;

        this.collectionView.RemainingItemsThreshold = 1;

        this.collectionView.RemainingItemsThresholdReached += collectionView_RemainingItemsThresholdReached;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region 컬렉션 뷰 잔혀 항목 임계치 도달시 처리하기 - collectionView_RemainingItemsThresholdReached(sender, e)

    /// <summary>
    /// 컬렉션 뷰 잔혀 항목 임계치 도달시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private async void collectionView_RemainingItemsThresholdReached(object sender, EventArgs e)
    {
        await DisplayAlert("INFORMATION", "RemainingItemsThresholdReached 이벤트가 발생했습니다.", "확인");

        this.collectionView.RemainingItemsThreshold = -1; // 테스트를 위한 설정이다.
    }

    #endregion
}